package FDN::Images::Jpeg;

use strict;
use warnings;
use base 'Exporter';

use FDN::Common::Logger;

our @EXPORT = qw (
	force_jpeg
	resize_jpeg
);

my $convert = `which convert`;
if ( ! $convert ) {
	die "I need convert";
}
chomp($convert);


sub force_jpeg($$) {
	my ( $from, $to ) = @_;
	if ( ! -f $from ) {
		error "File not found: $from";
		return undef;
	}
	if ( -f $to ) {
		error "File already exists: $to";
		return undef;
	}
	`$convert "$from" "$to" > /dev/null 2>&1`;
	if ( ! -f $to ) {
		error "Failed to convert $from to $to";
		return undef;
	}
	return $to;
}

sub resize_jpeg($$$) {
	my ( $from, $to, $size ) = @_;
	if ( ! -f $from ) {
		error "File not found: $from";
		return undef;
	}
	if ( -f $to ) {
		error "File already exists: $to";
		return undef;
	}
	if ( $size !~ /^\d+x\d+$/ ) {
		error "Invalid size '$size', expected <n>x<m>";
		return undef;
	}
	`$convert "$from" -resize $size +profile "*" "$to" > /dev/null 2>&1`;
	if ( ! -f $to ) {
		error "Failed to convert $from to $to";
		return undef;
	}
	return $to;
}


1;
